/**
 * generated by Xtext 2.25.0
 */
package org.xtext.example.methodname.methodName;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Case</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link org.xtext.example.methodname.methodName.Case#getKind <em>Kind</em>}</li>
 *   <li>{@link org.xtext.example.methodname.methodName.Case#getCondition <em>Condition</em>}</li>
 *   <li>{@link org.xtext.example.methodname.methodName.Case#getProperties <em>Properties</em>}</li>
 * </ul>
 *
 * @see org.xtext.example.methodname.methodName.MethodNamePackage#getCase()
 * @model
 * @generated
 */
public interface Case extends EObject
{
  /**
   * Returns the value of the '<em><b>Kind</b></em>' attribute.
   * The literals are from the enumeration {@link org.xtext.example.methodname.methodName.Kind}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the value of the '<em>Kind</em>' attribute.
   * @see org.xtext.example.methodname.methodName.Kind
   * @see #setKind(Kind)
   * @see org.xtext.example.methodname.methodName.MethodNamePackage#getCase_Kind()
   * @model
   * @generated
   */
  Kind getKind();

  /**
   * Sets the value of the '{@link org.xtext.example.methodname.methodName.Case#getKind <em>Kind</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Kind</em>' attribute.
   * @see org.xtext.example.methodname.methodName.Kind
   * @see #getKind()
   * @generated
   */
  void setKind(Kind value);

  /**
   * Returns the value of the '<em><b>Condition</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the value of the '<em>Condition</em>' containment reference.
   * @see #setCondition(Expr)
   * @see org.xtext.example.methodname.methodName.MethodNamePackage#getCase_Condition()
   * @model containment="true"
   * @generated
   */
  Expr getCondition();

  /**
   * Sets the value of the '{@link org.xtext.example.methodname.methodName.Case#getCondition <em>Condition</em>}' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Condition</em>' containment reference.
   * @see #getCondition()
   * @generated
   */
  void setCondition(Expr value);

  /**
   * Returns the value of the '<em><b>Properties</b></em>' containment reference list.
   * The list contents are of type {@link org.xtext.example.methodname.methodName.Property}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the value of the '<em>Properties</em>' containment reference list.
   * @see org.xtext.example.methodname.methodName.MethodNamePackage#getCase_Properties()
   * @model containment="true"
   * @generated
   */
  EList<Property> getProperties();

} // Case
